/*
	decode CPS-2 roms into raw 32x32 4bpp pixel data
	currently roms for batcir are hooked up as an example
	iq_132 - 6/10/20
*/

#include <stdio.h>

static void gfx_decode(unsigned char *rom, int gfxlen) // unshuffle and decode
{
	int i,j,k;
	unsigned char *tmp = (unsigned char*)malloc(gfxlen);
	
	memcpy (tmp, rom, gfxlen);
	memset (rom, 0, gfxlen * 2);
	
	for (i = 0; i < gfxlen*8; i++)
	{
		j = ((((i >> 3) & 0x1ffff0) >> 1) | (((i >> 3) & 8) << 17) | ((i >> 3) & 0xffe00007)) << 3; // step 1 unshuffle

		k = ((~i & 7) << 3) | ((j & 0x18) >> 3) | ((j & 0xffffffe0) << 1); // step 2 decode
	
		rom[k/8] |= ((tmp[i/8] >> (i & 7)) & 1) << (k & 7);	
	}
}

int main() // decode
{
	unsigned char *rom = (unsigned char*)malloc(0x1000000*2);

	// type 0 - ROM_LOAD64_WORD
	{
		int i,j;
		FILE *f[4];
	
		f[0] = fopen("btc.13m", "rb");
		f[1] = fopen("btc.15m", "rb");
		f[2] = fopen("btc.17m", "rb");
		f[3] = fopen("btc.19m", "rb");

		unsigned char *tmp = (unsigned char*)malloc(0x400000);
		
		for (i = 0; i < 4; i++)
		{
			fread (tmp, 0x400000, 1, f[i]);
			fclose (f[i]);

			for (j = 0; j < 0x400000; j++) { // load 2 bytes, skip 6 bytes, repeat.
				rom[(j & 1) + ((j & ~1) << 2) + (i * 2)] = tmp[j];
			}
		}

		free (tmp);
	}

	gfx_decode(rom, 0x1000000);

	FILE *fo = fopen("decoded.bin","wb");
	fwrite (rom, 0x1000000 * 2, 1, fo);
	fclose (fo);

	free (rom);
	
	return 0;
}

