/*
	Encode CPS-2 32x32 pixel data from raw 32x32 4bpp pixel data into CPS-2 rom format
	currently roms for batcir are hooked up as an example
	iq_132 - 6/10/20
*/

#include <stdio.h>

static void gfx_encode(unsigned char *rom, int gfxlen) // encode and shuffle
{
	int i,j,k;
	unsigned char *tmp = (unsigned char*)malloc(gfxlen);
	
	memcpy (tmp, rom, gfxlen);
	memset (rom, 0, gfxlen / 2);
	
	for (i = 0; i < gfxlen*8; i++)
	{
		k = ((i & 3) << 3) | (((i >> 3) & 7) ^ 7) | ((i & 0xffffffc0) >> 1); // step 1 encode

		j = (((k >> 3) << 1) & 0x1ffff0) | (((k >> 3) >> 17) & 8) | ((k >> 3) & 0xffe00007); // step 2 shuffle

		rom[j] |= ((tmp[i/8] >> (i & 7)) & 1) << (k & 7);	
	}
}

int main()
{
	unsigned char *rom = (unsigned char*)malloc(0x1000000*2);

	FILE *fo = fopen("decoded.bin","rb");
	fread (rom, 0x2000000, 1, fo);
	fclose (fo);

	gfx_encode(rom, 0x2000000);

	// type 0 - ROM_LOAD64_WORD
	{
		int i,j;
		FILE *f[4];
	
		f[0] = fopen("btc.13m_modified", "wb");
		f[1] = fopen("btc.15m_modified", "wb");
		f[2] = fopen("btc.17m_modified", "wb");
		f[3] = fopen("btc.19m_modified", "wb");

		unsigned char *tmp = (unsigned char*)malloc(0x400000);
		
		for (i = 0; i < 4; i++)
		{
			for (j = 0; j < 0x400000; j++) { // load 2 bytes, skip 6 bytes, repeat.
				tmp[j] = rom[(j & 1) + ((j & ~1) << 2) + (i * 2)];
			}

			fwrite (tmp, 0x400000, 1, f[i]);
			fclose (f[i]);
		}

		free (tmp);
	}

	free (rom);
	
	return 0;
}
